import java.awt.DisplayMode;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import vitamin.VTimer;
import com.sun.jna.Pointer;

import cl.nui.*;


CLNUI2 clnui;
Pointer motor, camera;
PImage colorData, depthData;


void setup()
{
    size( 640, 480 );
    frameRate( 10000 );

//    CLNUI2.loadLibrary( "CLNUIDevice.dll" );
    CLNUI2.loadLibrary( "C://Program Files (x86)//Code Laboratories//CL NUI Platform//SDK//Bin//CLNUIDevice.dll" );
//    CLNUI2.loadLibrary( "C://Program Files//Code Laboratories//CL NUI Platform//SDK//Bin//CLNUIDevice.dll" );

    clnui = new CLNUI2();
    clnui.createMotor();
    clnui.createCamera();
    clnui.startCamera();

    colorData = createImage( 640, 480, RGB );
    depthData = createImage( 640, 480, RGB );
}



public void draw()
{
    if( clnui.isLibraryLoaded() )
    {
        colorData.pixels = clnui.getColorArray( 300 );
        colorData.updatePixels();
        depthData.pixels = clnui.getDepthArray( 0 );
        depthData.updatePixels();	
    
        background( 0 );
        image( colorData, 0, 0, 320, 240 );
        image( depthData, 320, 0, 320, 240 );
    }
    else {
        background( random(255) );
    }
}


public void stop()
{
    if( clnui != null ) 
    {
        clnui.setMotorLed( 0 );
        clnui.stopMotor();    	
        clnui.stopCamera();
    }

    super.stop();
}

