import java.awt.DisplayMode;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import com.sun.jna.Pointer;
import vitamin.VTimer;

import cl.nui.*;


VKinect kinect;

PImage colorData, depthData;



        void setup()
        {
		size( 1024, 768 );
		frameRate( 10000 );
			    
		try {
			kinect = new VKinect();
			kinect.setTimeout( 300, 0 );	//2000, 1000 );
			//kinect.setColorMode( VKinect.MODE_RGB32 );
			//kinect.setDepthMode( VKinect.MODE_RGB32 );
			kinect.init();
			kinect.setNoiseRemoval( true );	// noise removal. for a static kinect, setting this to false can help on getting depth values
			kinect.setInvertDepth( true );	// invert depthmap
		} catch (Exception e) {
			e.printStackTrace();
		}

		colorData = createImage( 640, 480, RGB );
		depthData = createImage( 640, 480, RGB );

	}
	
	
	
	public void draw()
	{
                background( 66 );
                
		colorData.pixels = kinect.getColor();
		colorData.updatePixels();
		//depthData.pixels = kinect.getDepth();
		//depthData.updatePixels();
		convertDepthMap();
		image( colorData, 0, 0, 320, 240 );
	    	image( depthData, 320, 0, 320, 240 );
	}


	public void convertDepthMap()
	{
		// Convert depth to 8bit grayscale just for display
		short[] buffer = kinect.getRawDepth();
		//depthData.loadPixels();
		for( int i=0; i<640*480; i++ )
			depthData.pixels[i] = color( (buffer[i]>>8)&0xff );
		depthData.updatePixels();
	}


	public void stop()
        {
   	    if( kinect != null ) kinect.release();

	    super.stop();
	}

